#################################################
# huanchen 09/2016
#################################################

import sys
import os

class bcolors:
    HEADER = '\033[95m'
    OKBLUE = '\033[94m'
    OKGREEN = '\033[92m'
    WARNING = '\033[93m'
    FAIL = '\033[91m'
    ENDC = '\033[0m'
    BOLD = '\033[1m'
    UNDERLINE = '\033[4m'

testDir = 'gradingTests/'
studentTarballDir = 'studentTarballs/'
studentProgramDir = 'studentPrograms/'
studentSolsDir = 'studentSols/'
solsDir = 'solutions/'
diffResultDir = 'diffResults/'

for dirName, subdirList, fileList in os.walk(studentTarballDir) :
    for fname in fileList :
        cols = fname.split('-')
        andrewID = cols[0]

        cmd = 'mkdir ' + studentProgramDir + andrewID
        print bcolors.OKBLUE + cmd + bcolors.ENDC
        os.system(cmd)

        cmd = 'mkdir ' + studentSolsDir + andrewID
        print bcolors.OKBLUE + cmd + bcolors.ENDC
        os.system(cmd)

        cmd = 'mkdir ' + diffResultDir + andrewID
        print bcolors.OKBLUE + cmd + bcolors.ENDC
        os.system(cmd)

        os.system('pwd')

        cmd = 'tar xvfz ' + studentTarballDir + fname + ' -C ' + studentProgramDir + andrewID + '/'
        print bcolors.OKBLUE + cmd + bcolors.ENDC
        os.system(cmd)

############################################################################
for dirName, subdirList, fileList in os.walk(studentProgramDir) :
    for student in subdirList :
        #cmd = 'cd ' + studentProgramDir + student + '/SRC; make'
        #print bcolors.OKBLUE + cmd + bcolors.ENDC
        #os.system(cmd)

        for dirNametest, subdirListtest, fileListtest in os.walk(testDir) :
            for fname in fileListtest :
                testname = fname.split('.')[0]
                cmd = 'mkdir ' + studentSolsDir + student
                print bcolors.OKBLUE + cmd + bcolors.ENDC
                os.system(cmd)

                cmd = 'cd ' + studentProgramDir + student + '/SRC; make spotless; make; ./main < ../../../' + testDir + fname + ' > ../../../' + studentSolsDir + student + '/' + testname + '-' + student
                print bcolors.OKBLUE + cmd + bcolors.ENDC
                os.system(cmd)
    break

############################################################################

for dirName, subdirList, fileList in os.walk(studentSolsDir) :
    for student in subdirList :
        for dirNameStudent, subdirListStudent, fileListStudent in os.walk(studentSolsDir + student) :
            for fname in fileListStudent :
                testname = fname.split('-')[0]
                cmd = 'diff ' + studentSolsDir + student + '/' + fname + ' ' + solsDir + testname + '.sol > ' + diffResultDir + student + '/' + testname + '.diff'
                print bcolors.OKBLUE + cmd + bcolors.ENDC
                os.system(cmd)
    break

############################################################################

for dirName, subdirList, fileList in os.walk(diffResultDir) :
    for student in subdirList :
        print '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
        print 'andrewID = ' + student
        print '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
        for dirNameStudent, subdirListStudent, fileListStudent in os.walk(studentSolsDir + student) :
            for fname in fileListStudent :
                testname = fname.split('-')[0]
                print '********************* ' + testname + ' *********************'
                if os.path.getsize(diffResultDir + student + '/' + testname + '.diff') == 0 :
                    print bcolors.OKGREEN + 'PASS' + bcolors.ENDC
                else :
                    print bcolors.FAIL + 'NEED CHECK! Here is the diff:' + bcolors.ENDC
                    cmd = 'cat ' + diffResultDir + student + '/' + testname + '.diff'
                    os.system(cmd)

                while True:

                    option = raw_input("ok -- to continue to next test\n student -- to view student output\n solution -- to view solution\n")
                    
                    if option == 'ok' :
                        break
                    elif option == 'student' :
                        cmd = 'cat ' + studentSolsDir + student + '/' + fname
                        os.system(cmd)
                    elif option == 'solution' :
                        cmd = 'cat ' + solsDir + testname + '.sol'
                        os.system(cmd)
                    else :
                        print 'Unknown commnand. Please retry.'

